<?php
/*
  Plugin Name: MarcTV Art Directed Blogging
  Plugin URI: http://wordpress.org/extend/plugins/marctv-art-directed-blogging/
  Description: Simple put powerfull: adds the ability to reference a css file with a custom field for each article.
  Version: 1.2
  Author: Marc Tönsing
  Author URI: http://www.marctv.de
  License: GPL2
 */
/*
  Simple put powerfull: adds the ability to reference a css file with a custom field for each article.
  This plugin uses ideas and code snipplets from codecandies.de
  http://codecandies.de/2009/12/01/individuelle-artikelgestaltung-mit-wordpress/
 */

// return or print the value of metafield with key
function get_custom_field_value($key, $output = false) {
    global $post;
    if (function_exists('get_post_meta')) {
        $value = get_post_meta($post->ID, $key, true);
        if ($output == false) {
            return $value;
        } else {
            echo $value;
        }
    }
}

// enqueue stylesheet for individual styled articles
function post_add_stylesheet() {
    global $wp_query;
    $path = WP_CONTENT_URL . '/articlestyles/';
    $this_post = $wp_query->get_queried_object();
    if (is_object($this_post)) {
        $id = $this_post->ID;
        if (function_exists('get_post_meta') && get_post_meta($id, 'extraCss', true) != '') {
            wp_enqueue_style(
                    'extraCss', $path . get_post_meta($id, 'extraCss', true) . "/" . get_post_meta($id, 'extraCss', true) . '.css', array(), false, 'screen');

            if(!get_option('marctvadb_disable_sw')){
                wp_enqueue_style(
                        'extraCss_helper', WP_PLUGIN_URL . "/marctv-art-directed-blogging/helper.css", array(), false, 'screen');
                wp_enqueue_script(
                        "jquery.marctv_art_directed_blogging", WP_PLUGIN_URL . "/marctv-art-directed-blogging/marctv_art_directed_blogging_setup.js",
                        array("jquery"), "", 1);
            }
        }
        /* undocumented feature: google font api */
        if (function_exists('get_post_meta') && get_post_meta($id, 'googlefont', true) != '') {
            wp_enqueue_style('googlefont', 'http://fonts.googleapis.com/css?family=' . get_post_meta($id, 'googlefont', true), array(), false, 'screen');
        }
    }
}

function browser_body_class($classes) {
    global $wp_query;
    $this_post = $wp_query->get_queried_object();
    if (is_object($this_post)) {
        $id = $this_post->ID;
        if (function_exists('get_post_meta') && get_post_meta($id, 'extraCss', true) != '') {
            $classes[] = 'artdirected';
        }
    }
    return $classes;
}

function marctv_adb_add_admin_menu() {
    wp_enqueue_style(
            "marctv-adb-admin-settings", WP_PLUGIN_URL . "/marctv-art-directed-blogging/admin_helper.css",
            false, "1.0");
    add_options_page('Art Directed Blogging', 'Art Directed Blogging', 'edit_posts', 'marctv_adb', 'menu');
}

function menu() {

    if (isset($_POST['marctvadb-settings'])) {
        check_admin_referer('marctvadb-settings' . $_SERVER['REMOTE_ADDR'] . $_SERVER['HTTP_USER_AGENT']);
        update_option('marctvadb_disable_sw', trim(stripslashes($_POST['marctvadb-disable-js'])));
    }

    $disable_sw = get_option('marctvadb_disable_sw');
    
?>
    <div class="wrap">
        <h2>MarcTV Art Directed Blogging Settings</h2>
        <form method="post" action="">
            <input type="hidden" value="1" name="marctvadb-settings" id="marctvadb-settings" />
            <?php wp_nonce_field('marctvadb-settings' . $_SERVER['REMOTE_ADDR'] . $_SERVER['HTTP_USER_AGENT']); ?>
            <fieldset class="options"><legend>Style Switcher: The little X in the top right corner</legend>
                <label for="marctvadb-disable-js">Disable Style Switcher?
                    <input type="checkbox" <?php if ($disable_sw == true) {echo 'checked="checked"';} ?> value="true" name="marctvadb-disable-js" id="marctvadb-disable-js" />
                </label>
            </fieldset>
            <p class="submit"><input type="submit" name="submit" value="Save &raquo;" /></p>
        </form>
    </div>
<?php
}

if (!is_admin()) {
    add_action('wp_print_styles', 'post_add_stylesheet');
    add_filter('body_class', 'browser_body_class');
} else {
    add_action('admin_menu', 'marctv_adb_add_admin_menu');
}
?>
